import { ThemeProp } from '@uidu/theme/components';
import { PureComponent, ReactNode } from 'react';
import { ThemeAppearance, ThemeProps, ThemeTokens } from '../theme';
interface Props {
    /** The appearance type. */
    appearance: ThemeAppearance;
    /** Elements to be rendered inside the lozenge. This should ideally be just a word or two. */
    children?: ReactNode;
    /** Determines whether to apply the bold style or not. */
    isBold: boolean;
    /** max-width of lozenge container. Default to 200px. */
    maxWidth: number | string;
    /** The theme the component should use. */
    theme?: ThemeProp<ThemeTokens, ThemeProps>;
}
export default class Lozenge extends PureComponent<Props> {
    static defaultProps: {
        isBold: boolean;
        appearance: string;
        maxWidth: number;
    };
    render(): JSX.Element;
}
export {};
