'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _objectSpread = require('@babel/runtime/helpers/objectSpread2');
var _classCallCheck = require('@babel/runtime/helpers/classCallCheck');
var _createClass = require('@babel/runtime/helpers/createClass');
var _inherits = require('@babel/runtime/helpers/inherits');
var _createSuper = require('@babel/runtime/helpers/createSuper');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var react = require('react');
var _typeof = require('@babel/runtime/helpers/typeof');
var theme = require('@uidu/theme');
var styled = require('styled-components');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var styled__default = /*#__PURE__*/_interopDefault(styled);

/** Note:
 * Lozenge does not support dark mode at the moment.
 * Hence, color values are the same.
 */

var defaultBackgroundColor = {
  "default": {
    light: theme.colors.N40,
    dark: theme.colors.N40
  },
  inprogress: {
    light: theme.colors.B50,
    dark: theme.colors.B50
  },
  moved: {
    light: theme.colors.Y75,
    dark: theme.colors.Y75
  },
  "new": {
    light: theme.colors.P50,
    dark: theme.colors.P50
  },
  removed: {
    light: theme.colors.R50,
    dark: theme.colors.R50
  },
  success: {
    light: theme.colors.G50,
    dark: theme.colors.G50
  }
};
var defaultTextColor = {
  "default": {
    light: theme.colors.N500,
    dark: theme.colors.N500
  },
  inprogress: {
    light: theme.colors.B500,
    dark: theme.colors.B500
  },
  moved: {
    light: theme.colors.N800,
    dark: theme.colors.N800
  },
  "new": {
    light: theme.colors.P500,
    dark: theme.colors.P500
  },
  removed: {
    light: theme.colors.R500,
    dark: theme.colors.R500
  },
  success: {
    light: theme.colors.G500,
    dark: theme.colors.G500
  }
};
var boldBackgroundColor = {
  "default": {
    light: theme.colors.N500,
    dark: theme.colors.N500
  },
  inprogress: {
    light: theme.colors.B400,
    dark: theme.colors.B400
  },
  moved: {
    light: theme.colors.Y500,
    dark: theme.colors.Y500
  },
  "new": {
    light: theme.colors.P400,
    dark: theme.colors.P400
  },
  removed: {
    light: theme.colors.R400,
    dark: theme.colors.R400
  },
  success: {
    light: theme.colors.G400,
    dark: theme.colors.G400
  }
};
var boldTextColor = {
  "default": {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  inprogress: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  moved: {
    light: theme.colors.N800,
    dark: theme.colors.N800
  },
  "new": {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  removed: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  success: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  }
};
var Theme = theme.createTheme(function (_ref) {
  var appearance = _ref.appearance,
      isBold = _ref.isBold,
      maxWidth = _ref.maxWidth;
  return _objectSpread(_objectSpread({}, _typeof(appearance) === 'object' ? _objectSpread({
    backgroundColor: (isBold ? boldBackgroundColor : defaultBackgroundColor)["default"].light,
    textColor: (isBold ? boldTextColor : defaultTextColor)["default"].light
  }, appearance) : {
    backgroundColor: (isBold ? boldBackgroundColor[appearance] : defaultBackgroundColor[appearance]).light,
    textColor: (isBold ? boldTextColor[appearance] : defaultTextColor[appearance]).light
  }), {}, {
    maxWidth: maxWidth
  });
});

var BORDER_RADIUS = "40px";
var Container = styled__default["default"].span.withConfig({
  displayName: "Container",
  componentId: "sc-5z8x30-0"
})(["background-color:", ";color:", ";max-width:100%;vertical-align:baseline;line-height:20px;display:inline-block;padding:1px 8px;font-size:12px;font-weight:500;letter-spacing:0.05em;border-radius:", ";text-transform:uppercase;"], function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.textColor;
}, BORDER_RADIUS);

var HORIZONTAL_SPACING = "".concat(theme.gridSize() / 2, "px");
var Content = styled__default["default"].span.withConfig({
  displayName: "Content",
  componentId: "sc-kuvtw4-0"
})(["display:inline-block;vertical-align:top;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;box-sizing:border-box;padding:0 ", ";max-width:", ";width:100%;"], HORIZONTAL_SPACING, function (props) {
  return typeof props.maxWidth === 'number' ? "".concat(props.maxWidth, "px") : props.maxWidth;
});

var Lozenge = /*#__PURE__*/function (_PureComponent) {
  _inherits(Lozenge, _PureComponent);

  var _super = _createSuper(Lozenge);

  function Lozenge() {
    _classCallCheck(this, Lozenge);

    return _super.apply(this, arguments);
  }

  _createClass(Lozenge, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          theme = _this$props.theme,
          _children = _this$props.children;
      return /*#__PURE__*/jsxRuntime.jsx(Theme.Provider, {
        value: theme,
        children: /*#__PURE__*/jsxRuntime.jsx(Theme.Consumer, _objectSpread(_objectSpread({}, this.props), {}, {
          children: function children(tokens) {
            return /*#__PURE__*/jsxRuntime.jsx(Container, _objectSpread(_objectSpread({}, tokens), {}, {
              children: /*#__PURE__*/jsxRuntime.jsx(Content, _objectSpread(_objectSpread({}, tokens), {}, {
                children: _children
              }))
            }));
          }
        }))
      });
    }
  }]);

  return Lozenge;
}(react.PureComponent);

_defineProperty(Lozenge, "defaultProps", {
  isBold: false,
  appearance: 'default',
  maxWidth: 200
});

exports["default"] = Lozenge;
